package main

import (
	"git.pixeltamer.net/gopub/logfunk"
)

func main() {
	log := logfunk.MakeF(logfunk.StdSink(logfunk.ShortTime), logfunk.Module("Test"), logfunk.MinLevel(logfunk.Spam))

	log(logfunk.KV("Test1", 42), "Hello world #1!")

	log2 := logfunk.MakeF(log)
	log2("Hello world #2!")

	log3 := logfunk.MakeF(log2, logfunk.Module("SubMod"), logfunk.Warn, logfunk.MinLevel(logfunk.Info), logfunk.KV("Common", 123))
	log3(logfunk.KV("Test3", 42), logfunk.ShowCaller, "Hello world #3!")
	log3(logfunk.KV("Test3", 42), "Hello world #3!")

	log3(logfunk.KV("Test4", 42), logfunk.MinLevel(logfunk.Info), "Hello world #4!\n2nd Line\n3rd Line\n%+#v", struct {
		A int
		B string
	}{
		A: 42, B: "Test",
	})
}
